{-# LANGUAGE LambdaCase #-}
module Sudoku.Render (unstructured, hints) where
import Sudoku (Sudoku, orderedIndices, translateIntIndex)
import Sudoku.Field (Field)
import qualified Sudoku.Field as Field
import qualified Data.Functor.Rep as Representable
import Data.Set (Set)
import Graphics.Text.Box (Box)
import qualified Graphics.Text.Box as Box
import qualified Data.Set as Set
import Data.Text (Text)

unstructured :: Sudoku (Maybe Field) -> String
unstructured sudoku = let
     characters = Field.maybeToDigit <$> sudoku

     in unlines $ (Representable.index characters <$>) <$> orderedIndices

hints :: Sudoku (Either Field (Set Field)) -> Text
hints sudoku = let
  
  boxes = fieldBox <$> sudoku :: Sudoku Box
  
  in Box.render $ Box.asciiGrid (9, 9) (Representable.index boxes . Sudoku.translateIntIndex)

fieldBox :: Either Field (Set Field) -> Box
fieldBox = \case
  Left value -> Box.square 3 (const $ Field.toDigit value)
  Right options -> Box.square 3 $ \ (row, col) -> let
    option = toEnum $ row * 3 + col

    in if option `Set.member` options
      then Field.toDigit option
      else ' '

